'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _uiCore = require('@servicenow/ui-core');

var _locals = require('./locals');

var _cast = require('./cast');

var _defaultBehaviors = require('./default-behaviors');

var _manageableProperties = require('./manageable-properties');

var _onRender = require('./on-render');

const createEnhancedElement = (name, baseConfig = {}) => {
	let mergedConfig = (0, _cast.extendWithCast)(baseConfig);
	mergedConfig = (0, _locals.extendWithLocals)(mergedConfig);
	mergedConfig = (0, _defaultBehaviors.extendWithDefaultBehaviors)(mergedConfig);
	mergedConfig = (0, _manageableProperties.extendWithManageableProperties)(name, mergedConfig);
	mergedConfig = (0, _onRender.extendWithOnRender)(mergedConfig);
	(0, _uiCore.createCustomElement)(name, mergedConfig);
};

exports.default = createEnhancedElement;